#ifndef	WILD_OBJS_H
#define WILD_OBJS_H

#include <wild/wild.h>

#define	OBJECT_Scene	1
#define	OBJECT_World	2
#define	OBJECT_Arena	3
#define	OBJECT_Alien	4
#define	OBJECT_Sector	5
#define	OBJECT_Face	6
#define	OBJECT_Edge	7
#define	OBJECT_Point	8
#define	OBJECT_Light	9
#define	OBJECT_Texture	10
#define OBJECT_Entity	11
#define OBJECT_Nebula	12	/* those are only used when saving,*/
#define OBJECT_Wire	13	/* when communicating with the*/
#define OBJECT_Shell	14	/* SaverModule.*/
#define OBJECT_Action	15
#define	OBJECT_Move	16

#define ATTR_BASE	WILD_OTHERSTD+0x50000
#define ATTR_TOP 	ATTR_BASE+0x0fff

#define FRIEND_BASE	ATTR_BASE+0x1000
#define FRIEND_TOP	FRIEND_BASE+0x0fff

#define CHILD_BASE	ATTR_BASE+0x2000
#define CHILD_TOP	CHILD_BASE+0x0fff

#define	ATTR_SCENE_CAMERA	ATTR_BASE+0x0000
#define	ATTR_SCENE_PALETTE	ATTR_BASE+0x0001
#define	CHILD_SCENE_WORLD	ATTR_BASE+0x2000

#define FRIEND_WORLD_SCENE	ATTR_BASE+0x1100
#define FRIEND_WORLD_PLAYER	ATTR_BASE+0x1101
#define CHILD_WORLD_ARENA	ATTR_BASE+0x2100
#define CHILD_WORLD_TEXTURE	ATTR_BASE+0x2101

#define	ATTR_ARENA_VIEWBOUNDS	ATTR_BASE+0x0200
#define	ATTR_ARENA_INITBOUNDS	ATTR_BASE+0x0201
#define	ATTR_ARENA_KILLBOUNDS	ATTR_BASE+0x0202
#define FRIEND_ARENA_WORLD	ATTR_BASE+0x1200
#define	CHILD_ARENA_LIGHT	ATTR_BASE+0x2200
#define CHILD_ARENA_ALIEN	ATTR_BASE+0x2201

#define FRIEND_ALIEN_ARENA	ATTR_BASE+0x1300
#define CHILD_ALIEN_SECTOR	ATTR_BASE+0x2300

#define ATTR_SECTOR_BOUNDS	ATTR_BASE+0x0400
#define FRIEND_SECTOR_ALIEN	ATTR_BASE+0x1400
#define CHILD_SECTOR_NEBULA	ATTR_BASE+0x2400
#define CHILD_SECTOR_WIRE	ATTR_BASE+0x2401
#define CHILD_SECTOR_SHELL	ATTR_BASE+0x2402

#define ATTR_ENTITY_REF		ATTR_BASE+0x0500
#define ATTR_ENTITY_FLAGS	ATTR_BASE+0x0501
#define FRIEND_ENTITY_PARENT	ATTR_BASE+0x1500

#define CHILD_NEBULA_POINT	ATTR_BASE+0x2600

#define CHILD_WIRE_EDGE		ATTR_BASE+0x2700

#define FRIEND_SHELL_ROOT	ATTR_BASE+0x1800
#define CHILD_SHELL_FACE	ATTR_BASE+0x2800

#define ATTR_FACE_TXA		ATTR_BASE+0x0900
#define ATTR_FACE_TXB		ATTR_BASE+0x0901
#define ATTR_FACE_TXC		ATTR_BASE+0x0902
#define ATTR_FACE_TYA		ATTR_BASE+0x0903
#define ATTR_FACE_TYB		ATTR_BASE+0x0904
#define ATTR_FACE_TYC		ATTR_BASE+0x0905
#define ATTR_FACE_FLAGS		ATTR_BASE+0x0906
#define FRIEND_FACE_POINTA	ATTR_BASE+0x1900
#define FRIEND_FACE_POINTB	ATTR_BASE+0x1901
#define FRIEND_FACE_POINTC	ATTR_BASE+0x1902
#define FRIEND_FACE_EDGEA	ATTR_BASE+0x1903
#define FRIEND_FACE_EDGEB	ATTR_BASE+0x1904
#define FRIEND_FACE_EDGEC	ATTR_BASE+0x1905
#define FRIEND_FACE_SECTOR	ATTR_BASE+0x1906
#define FRIEND_FACE_PLUS	ATTR_BASE+0x1907
#define FRIEND_FACE_MINUS	ATTR_BASE+0x1908
#define FRIEND_FACE_TEXTURE	ATTR_BASE+0x1909

#define ATTR_EDGE_FLAGS		ATTR_BASE+0x0a00
#define FRIEND_EDGE_POINTA	ATTR_BASE+0x1a01
#define FRIEND_EDGE_POINTB	ATTR_BASE+0x1a02
#define FRIEND_EDGE_SECTOR	ATTR_BASE+0x1a03

#define ATTR_POINT_COLOR	ATTR_BASE+0x0b00
#define ATTR_POINT_FLAGS	ATTR_BASE+0x0b01
#define ATTR_POINT_VEK		ATTR_BASE+0x0b02
#define FRIEND_POINT_SECTOR	ATTR_BASE+0x1b00

#define ATTR_LIGHT_COLOR	ATTR_BASE+0x0c00
#define ATTR_LIGHT_INTENSITY	ATTR_BASE+0x0c01
#define FRIEND_LIGHT_ARENA	ATTR_BASE+0x1c00
#define FRIEND_LIGHT_POINT	ATTR_BASE+0x1c01

#define ATTR_TEXTURE_HOOK	ATTR_BASE+0x0d00
#define ATTR_TEXTURE_WIDTH	ATTR_BASE+0x0d01
#define ATTR_TEXTURE_HEIGHT	ATTR_BASE+0x0d02
#define ATTR_TEXTURE_TRUEIMAGE	ATTR_BASE+0x0d03	/* used when saving only ! */
#define FRIEND_TEXTURE_WORLD	ATTR_BASE+0x1d00
#define SPECIAL_TEXTURE_INIT	ATTR_BASE+0x3d00

#define	ATTR_ACTION_SECTORS	ATTR_BASE+0x0e00
#define	ATTR_ACTION_STOPCHECK	ATTR_BASE+0x0e01	/* add a stopcheck Hook */
#define	ATTR_ACTION_STOPCALL	ATTR_BASE+0x0e02

#define	ATTR_MOVE_FLAGS		ATTR_BASE+0x0f00
#define	ATTR_MOVE_SECTORID	ATTR_BASE+0x0f01
#define	ATTR_MOVE_DURATION	ATTR_BASE+0x0f02
#define	ATTR_MOVE_STOPCHECK	ATTR_BASE+0x0f03
#define	ATTR_MOVE_COMMANDLIST	ATTR_BASE+0x0f04
#define	ATTR_MOVE_STARTER	ATTR_BASE+0x0f05
#define	FRIEND_MOVE_ACTION	ATTR_BASE+0x1f00

#endif
